#! /usr/bin/env node
'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _formData = require('form-data');

var _formData2 = _interopRequireDefault(_formData);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _util = require('./utils/util');

var utilFunctions = _interopRequireWildcard(_util);

var _morphlingRestart = require('./morphling-restart');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var applyAction = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dir) {
        var config, port, isOverrideFile, url, splitDir, filename, filenameForOverride, listUrl, request, _ref2, fileExists, form;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return utilFunctions.returnConfigIfExists();

                    case 3:
                        config = _context.sent;
                        port = config.port || _commander2.default.port || 8883;
                        isOverrideFile = _commander2.default.override || false;
                        url = 'http://localhost:' + port;
                        splitDir = dir.split('/');
                        filename = splitDir[splitDir.length - 1];
                        filenameForOverride = isOverrideFile ? 'morphling-override-' + filename : filename;
                        listUrl = url + '/morphling/list?filename=' + filenameForOverride;
                        _context.next = 13;
                        return (0, _nodeFetch2.default)(listUrl);

                    case 13:
                        request = _context.sent;
                        _context.next = 16;
                        return request.json();

                    case 16:
                        _ref2 = _context.sent;
                        fileExists = _ref2.fileExists;

                        if (!(!fileExists || _commander2.default.force)) {
                            _context.next = 30;
                            break;
                        }

                        console.log(_chalk2.default.green('Applying \'' + _chalk2.default.bold(filename) + '\' to Morphling ...'));

                        form = new _formData2.default();


                        form.append('file', _fs2.default.createReadStream(process.cwd() + '/' + dir));
                        form.append('fileName', filenameForOverride);

                        _context.next = 25;
                        return (0, _nodeFetch2.default)(url + '/morphling/apply' + (isOverrideFile ? '?override=true' : ''), {
                            method: 'POST',
                            body: form
                        });

                    case 25:
                        console.log(_chalk2.default.green((isOverrideFile ? 'Override file' : 'File') + ' \'' + _chalk2.default.bold(filename) + '\' successfully uploaded! Restarting...'));
                        _context.next = 28;
                        return (0, _morphlingRestart.restartAction)();

                    case 28:
                        _context.next = 31;
                        break;

                    case 30:
                        console.log(_chalk2.default.red((isOverrideFile ? 'Override file' : 'File') + ' \'' + _chalk2.default.bold(filename) + '\' already exists on Morphling. Type morphling apply with -f to force.'));

                    case 31:
                        _context.next = 36;
                        break;

                    case 33:
                        _context.prev = 33;
                        _context.t0 = _context['catch'](0);

                        if (_context.t0.code === 'ECONNREFUSED') {
                            console.log(_chalk2.default.red('Connection to Morphling was refused. Is Morphling currently running?'));
                        }

                    case 36:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[0, 33]]);
    }));

    return function applyAction(_x) {
        return _ref.apply(this, arguments);
    };
}();

_commander2.default.action(applyAction).option('-p, --port <port>', 'A port number', parseInt).option('-v, --verbose', 'Print all the things').option('-f, --force', 'Erase file that might already exist').option('-o --override', 'Apply a custom override to morphling').parse(process.argv);