#! /usr/bin/env node
'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _prompt = require('prompt');

var _prompt2 = _interopRequireDefault(_prompt);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _promptProps = require('./utils/prompt-props');

var _promptProps2 = _interopRequireDefault(_promptProps);

var _util = require('./utils/util');

var utilFunctions = _interopRequireWildcard(_util);

var _prettyjson = require('prettyjson');

var _prettyjson2 = _interopRequireDefault(_prettyjson);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.option('-p, --port <port>', 'A port number', parseInt).option('-v, --verbose', 'Print all the things').option('-f, --force', 'Override existing config').option('-d --delete', 'Delete existing configuration').option('-s --show', 'Show existing configuration').parse(process.argv);

(0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var configFileAlreadyExists, config;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    _context2.next = 2;
                    return utilFunctions.checkConfigFileExistence();

                case 2:
                    configFileAlreadyExists = _context2.sent;

                    if (!_commander2.default.delete) {
                        _context2.next = 16;
                        break;
                    }

                    _context2.prev = 4;
                    _context2.next = 7;
                    return (0, _util.deleteConfigFile)();

                case 7:
                    console.log('' + _chalk2.default.green('Config deleted'));
                    _context2.next = 13;
                    break;

                case 10:
                    _context2.prev = 10;
                    _context2.t0 = _context2['catch'](4);

                    if (_context2.t0.code === 'ENOENT') {
                        console.log('' + _chalk2.default.red(' 😱 Config file does not exist !'));
                        console.log(_chalk2.default.blue('' + _chalk2.default.bold('morphling config')) + ' will walk you through the config');
                    } else {
                        console.error(_context2.t0);
                    }

                case 13:
                    return _context2.abrupt('return');

                case 16:
                    if (!_commander2.default.show) {
                        _context2.next = 31;
                        break;
                    }

                    _context2.prev = 17;
                    _context2.next = 20;
                    return (0, _util.returnConfigIfExists)();

                case 20:
                    config = _context2.sent;

                    console.log(' 👇 Current configuration');
                    console.log('');
                    console.log(_prettyjson2.default.render(config));
                    console.log('');
                    _context2.next = 30;
                    break;

                case 27:
                    _context2.prev = 27;
                    _context2.t1 = _context2['catch'](17);

                    if (_context2.t1.code === 'ENOENT') {
                        console.log('' + _chalk2.default.red(' 😱 Config file does not exist !'));
                        console.log(_chalk2.default.blue('' + _chalk2.default.bold('morphling config')) + ' will walk you through the config');
                    } else {
                        console.error(_context2.t1);
                    }

                case 30:
                    return _context2.abrupt('return');

                case 31:

                    _prompt2.default.start();
                    _prompt2.default.message = _promptProps2.default.message;

                    if (!(configFileAlreadyExists && !_commander2.default.force)) {
                        _context2.next = 36;
                        break;
                    }

                    console.log(_chalk2.default.red(' \uD83D\uDE31 Config file already exists! Use ' + _chalk2.default.bold('morphling config') + ' with -f to override the existing config.'));
                    return _context2.abrupt('return');

                case 36:

                    _prompt2.default.get(_promptProps2.default.propertiesList.config, function () {
                        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(err, res) {
                            var objectTosave;
                            return _regenerator2.default.wrap(function _callee$(_context) {
                                while (1) {
                                    switch (_context.prev = _context.next) {
                                        case 0:
                                            if (!err) {
                                                _context.next = 3;
                                                break;
                                            }

                                            console.log(err);
                                            return _context.abrupt('return');

                                        case 3:
                                            if (!res.makeDefault) {
                                                _context.next = 19;
                                                break;
                                            }

                                            objectTosave = {
                                                port: res.port,
                                                default: res.makeDefault

                                            };
                                            _context.prev = 5;
                                            _context.next = 8;
                                            return utilFunctions.writeConfigFile(objectTosave);

                                        case 8:
                                            _context.next = 14;
                                            break;

                                        case 10:
                                            _context.prev = 10;
                                            _context.t0 = _context['catch'](5);

                                            console.error('ERROR WHILE SAVING CONFIG', _context.t0);
                                            return _context.abrupt('return');

                                        case 14:
                                            console.log(_chalk2.default.green(' \uD83D\uDD96 Alright, Morphling will always run on ' + res.port + '!'));
                                            console.log(_chalk2.default.white(' \uD83D\uDE09 You can change that by doing ' + _chalk2.default.bold('morphling config') + ' again'));
                                            console.log(_chalk2.default.white(' \uD83D\uDE09 Now start morphling by using ' + _chalk2.default.bold('morphling start')));
                                            _context.next = 20;
                                            break;

                                        case 19:
                                            console.log(_chalk2.default.green(' \uD83D\uDD96 Alright, Morphling will run on ' + res.port + ', but config will not be saved!'));

                                        case 20:
                                        case 'end':
                                            return _context.stop();
                                    }
                                }
                            }, _callee, undefined, [[5, 10]]);
                        }));

                        return function (_x, _x2) {
                            return _ref2.apply(this, arguments);
                        };
                    }());

                case 37:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _callee2, undefined, [[4, 10], [17, 27]]);
}))();