#! /usr/bin/env node
'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _util = require('./utils/util');

var utilFunctions = _interopRequireWildcard(_util);

var _util2 = require('util');

var util = _interopRequireWildcard(_util2);

var _prettyjson = require('prettyjson');

var _prettyjson2 = _interopRequireDefault(_prettyjson);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeAction = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(filename) {
        var port, config, url, request, res, table, bodyIsEmpty;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        port = void 0;
                        _context.next = 4;
                        return utilFunctions.returnConfigIfExists();

                    case 4:
                        config = _context.sent;


                        if (config) {
                            port = config.port;
                        } else {
                            port = _commander2.default.port || 8883;
                        }

                        url = 'http://localhost:' + port + '/morphling/describe?filename=' + filename;
                        _context.next = 9;
                        return (0, _nodeFetch2.default)(url);

                    case 9:
                        request = _context.sent;

                        if (!(request.status === 404)) {
                            _context.next = 13;
                            break;
                        }

                        console.log(_chalk2.default.red(' \uD83D\uDE31 File was not found. Use ' + _chalk2.default.bold('morphling list -o') + ' to list all overrides'));
                        return _context.abrupt('return');

                    case 13:
                        _context.next = 15;
                        return request.json();

                    case 15:
                        res = _context.sent;
                        table = new _cliTable2.default({
                            head: [_chalk2.default.blue('Method'), _chalk2.default.blue('Route'), _chalk2.default.blue('Code'), _chalk2.default.blue('Empty Response?'), _chalk2.default.blue('Enabled')]
                        });
                        bodyIsEmpty = _lodash2.default.keys(res.body).length === 0;

                        console.log('');

                        console.log('Description for override ' + _chalk2.default.bold(filename));

                        table.push([res.method, res.route, res.httpCode, bodyIsEmpty ? 'Yes' : 'No', res.overrideStatus ? _chalk2.default.green('ON') : _chalk2.default.red('OFF')]);

                        console.log(table.toString());

                        if (!bodyIsEmpty && !_commander2.default.withBody && !_commander2.default.withBodyRaw) {
                            console.log(_chalk2.default.blue('Use ' + _chalk2.default.bold('morphling describe -b <filename>') + ' to display the body'));
                        }

                        if (_commander2.default.withBody || _commander2.default.withBodyRaw) {
                            if (bodyIsEmpty) {
                                console.log(_chalk2.default.red(' \uD83D\uDE31 Body is empty!'));
                            } else {
                                console.log('');
                                if (!_commander2.default.withBodyRaw) {
                                    console.log(' 👇 Prettified body:');
                                    console.log('');
                                    console.log(_prettyjson2.default.render(res.body));
                                    console.log('');
                                } else {
                                    console.log(' 👇 Raw body:');
                                    console.log('');
                                    console.log(util.inspect(res.body, { depth: null, colors: true }));
                                    console.log('');
                                }
                            }
                        }
                        _context.next = 30;
                        break;

                    case 26:
                        _context.prev = 26;
                        _context.t0 = _context['catch'](0);

                        if (_context.t0.code === 'ECONNREFUSED') {
                            console.log(_chalk2.default.red(' \uD83D\uDE31 Connection to Morphling was refused. Is Morphling currently running?'));
                        }
                        console.error(_context.t0);

                    case 30:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[0, 26]]);
    }));

    return function describeAction(_x) {
        return _ref.apply(this, arguments);
    };
}();

_commander2.default.action(describeAction).option('-p, --port <port>', 'A port number', parseInt).option('-v, --verbose', 'Print all the things').option('-b, --with-body', 'Pretty-print the body').option('-r, --with-body-raw', 'Print the body as-is').parse(process.argv);

if (_commander2.default.args.length === 0) {
    console.log(_chalk2.default.red(' \uD83D\uDE31 No filename provided. Use ' + _chalk2.default.bold('morphling list -o') + ' to list all overrides'));
}