#! /usr/bin/env node
'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _util = require('./utils/util');

var utilFunctions = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.option('-v, --verbose', 'Print all the things').option('-o --overrides', 'List overrides').option('-p, --port <port>', 'A port number', parseInt).parse(process.argv);

(0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var port, config, listOverrides, url, request, _ref2, files, table;

    return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    _context.prev = 0;
                    port = void 0;
                    _context.next = 4;
                    return utilFunctions.returnConfigIfExists();

                case 4:
                    config = _context.sent;


                    if (config) {
                        port = config.port;
                    } else {
                        port = _commander2.default.port || 8883;
                    }

                    listOverrides = !!_commander2.default.overrides;
                    url = 'http://localhost:' + port + '/morphling/list?list-overrides=' + listOverrides;
                    _context.next = 10;
                    return (0, _nodeFetch2.default)(url);

                case 10:
                    request = _context.sent;
                    _context.next = 13;
                    return request.json();

                case 13:
                    _ref2 = _context.sent;
                    files = _ref2.files;

                    if (!(files.length === 0)) {
                        _context.next = 18;
                        break;
                    }

                    console.log(_chalk2.default.yellow(' \uD83E\uDD14 No ' + (!listOverrides ? 'swaggers' : 'overrides') + ' saved on morphling!'));
                    return _context.abrupt('return');

                case 18:

                    console.log(_chalk2.default.green(' \uD83D\uDC47 ' + (!listOverrides ? 'Swaggers' : 'Overrides') + ' currently saved on Morphling:'));
                    table = new _cliTable2.default({ head: [_chalk2.default.blue('File name')] });


                    _lodash2.default.each(files, function (file) {
                        table.push([file]);
                    });
                    console.log(table.toString());

                    _context.next = 28;
                    break;

                case 24:
                    _context.prev = 24;
                    _context.t0 = _context['catch'](0);

                    if (_context.t0.code === 'ECONNREFUSED') {
                        console.log(_chalk2.default.red(' \uD83D\uDE31 Connection to Morphling was refused. Is Morphling currently running?'));
                    }
                    console.log('Error in response', _context.t0);

                case 28:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, undefined, [[0, 24]]);
}))();