#! /usr/bin/env node
'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _util = require('./utils/util');

var utilFunctions = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toggleAction = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(filename) {
        var port, config, url, request, res, status;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        port = void 0;
                        _context.next = 4;
                        return utilFunctions.returnConfigIfExists();

                    case 4:
                        config = _context.sent;


                        if (config) {
                            port = config.port;
                        } else {
                            port = _commander2.default.port || 8883;
                        }

                        url = 'http://localhost:' + port + '/morphling/toggle';


                        if (_commander2.default.enableAll) {
                            url += '?enable=all';
                        } else if (_commander2.default.disableAll) {
                            url += '?enable=none';
                        } else {
                            url += '?filename=' + filename;
                        }

                        _context.next = 10;
                        return (0, _nodeFetch2.default)(url);

                    case 10:
                        request = _context.sent;
                        _context.next = 13;
                        return request.json();

                    case 13:
                        res = _context.sent;
                        status = res.overrideStatus ? _chalk2.default.green('ON') : _chalk2.default.red('OFF');

                        if (_commander2.default.enableAll || _commander2.default.disableAll) {
                            console.log(' \uD83D\uDC4D All overrides are now ' + status);
                        } else {
                            console.log(' \uD83D\uDC4D Override ' + filename + ' is now ' + status);
                        }

                        _context.next = 23;
                        break;

                    case 18:
                        _context.prev = 18;
                        _context.t0 = _context['catch'](0);

                        if (!(_context.t0.code === 'ECONNREFUSED')) {
                            _context.next = 23;
                            break;
                        }

                        console.log(_chalk2.default.red(' \uD83D\uDE31 Connection to Morphling was refused. Is Morphling currently running?'));
                        return _context.abrupt('return');

                    case 23:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[0, 18]]);
    }));

    return function toggleAction(_x) {
        return _ref.apply(this, arguments);
    };
}();

_commander2.default.action(toggleAction).option('-p, --port <port>', 'A port number', parseInt).option('-v, --verbose', 'Print all the things').option('-e, --enable-all', 'Enable all overrides').option('-d, --disable-all', 'Disable all overrides').parse(process.argv);

if (_commander2.default.args.length === 0 && !_commander2.default.enableAll && !_commander2.default.disableAll) {
    console.log(_chalk2.default.red(' \uD83D\uDE31 No filename provided. Use ' + _chalk2.default.bold('morphling list -o') + ' to list all overrides'));
}

if (_commander2.default.enableAll || _commander2.default.disableAll) {
    (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.prev = 0;
                        _context2.next = 3;
                        return toggleAction();

                    case 3:
                        _context2.next = 7;
                        break;

                    case 5:
                        _context2.prev = 5;
                        _context2.t0 = _context2['catch'](0);

                    case 7:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined, [[0, 5]]);
    }))();
}