'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.overrideFileParser = exports.parseFile = exports.returnConfigIfExists = exports.readFile = exports.checkConfigFileExistence = exports.deleteConfigFile = exports.writeConfigFile = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _getInstalledPath = require('get-installed-path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var env = process.env.DEV ? '' : '/bin';

var writeConfigFile = exports.writeConfigFile = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(objectToWrite) {
        var installedPath, path;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return (0, _getInstalledPath.getInstalledPath)('morphlingjs');

                    case 2:
                        installedPath = _context.sent;
                        path = '' + installedPath + env + '/cli/morphling-config.json';
                        return _context.abrupt('return', new _promise2.default(function (resolve, reject) {
                            _fs2.default.writeFile(path, (0, _stringify2.default)(objectToWrite), function (err) {
                                if (err) {
                                    console.log(err);
                                    return reject(err);
                                }
                                return resolve();
                            });
                        }));

                    case 5:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function writeConfigFile(_x) {
        return _ref.apply(this, arguments);
    };
}();

var deleteConfigFile = exports.deleteConfigFile = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var installedPath, path;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return (0, _getInstalledPath.getInstalledPath)('morphlingjs');

                    case 2:
                        installedPath = _context2.sent;
                        path = '' + installedPath + env + '/cli/morphling-config.json';
                        return _context2.abrupt('return', new _promise2.default(function (resolve, reject) {
                            _fs2.default.unlink(path, function (err) {
                                if (err) {
                                    return reject(err);
                                }

                                return resolve();
                            });
                        }));

                    case 5:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }));

    return function deleteConfigFile() {
        return _ref2.apply(this, arguments);
    };
}();

var checkConfigFileExistence = exports.checkConfigFileExistence = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var installedPath, path;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return (0, _getInstalledPath.getInstalledPath)('morphlingjs');

                    case 2:
                        installedPath = _context3.sent;
                        path = '' + installedPath + env + '/cli/morphling-config.json';
                        return _context3.abrupt('return', new _promise2.default(function (resolve) {
                            _fs2.default.stat(path, function (e) {
                                if (e) return resolve(false);

                                return resolve(true);
                            });
                        }));

                    case 5:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, undefined);
    }));

    return function checkConfigFileExistence() {
        return _ref3.apply(this, arguments);
    };
}();

var readFile = exports.readFile = function () {
    var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(path) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        return _context4.abrupt('return', new _promise2.default(function (resolve, reject) {
                            _fs2.default.readFile(path, 'utf8', function (err, data) {
                                if (err) {
                                    return reject(err);
                                }
                                return resolve(data);
                            });
                        }));

                    case 1:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, undefined);
    }));

    return function readFile(_x2) {
        return _ref4.apply(this, arguments);
    };
}();

var returnConfigIfExists = exports.returnConfigIfExists = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var installedPath, path;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.next = 2;
                        return (0, _getInstalledPath.getInstalledPath)('morphlingjs');

                    case 2:
                        installedPath = _context5.sent;
                        path = '' + installedPath + env + '/cli/morphling-config.json';
                        _context5.next = 6;
                        return checkConfigFileExistence();

                    case 6:
                        if (!_context5.sent) {
                            _context5.next = 14;
                            break;
                        }

                        _context5.t1 = JSON;
                        _context5.next = 10;
                        return readFile(path);

                    case 10:
                        _context5.t2 = _context5.sent;
                        _context5.t0 = _context5.t1.parse.call(_context5.t1, _context5.t2);
                        _context5.next = 15;
                        break;

                    case 14:
                        _context5.t0 = false;

                    case 15:
                        return _context5.abrupt('return', _context5.t0);

                    case 16:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, undefined);
    }));

    return function returnConfigIfExists() {
        return _ref5.apply(this, arguments);
    };
}();

var parseFile = exports.parseFile = function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var fileContent, parsedFile;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.prev = 0;
                        _context6.next = 3;
                        return readFile(path);

                    case 3:
                        fileContent = _context6.sent;
                        parsedFile = overrideFileParser(fileContent);
                        _context6.next = 10;
                        break;

                    case 7:
                        _context6.prev = 7;
                        _context6.t0 = _context6['catch'](0);

                        console.log(_context6.t0);

                    case 10:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, undefined, [[0, 7]]);
    }));

    return function parseFile() {
        return _ref6.apply(this, arguments);
    };
}();

var overrideFileParser = exports.overrideFileParser = function () {
    var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(file) {
        var fileContent;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        fileContent = void 0;
                        _context7.prev = 1;

                        fileContent = JSON.parse(file);
                        _context7.next = 8;
                        break;

                    case 5:
                        _context7.prev = 5;
                        _context7.t0 = _context7['catch'](1);
                        return _context7.abrupt('return', _promise2.default.reject('UNPARSED_JSON'));

                    case 8:
                        if (fileContent.route) {
                            _context7.next = 10;
                            break;
                        }

                        return _context7.abrupt('return', _promise2.default.reject(new Error('NO_ROUTE_DEFINED')));

                    case 10:
                        if (fileContent.method) {
                            _context7.next = 12;
                            break;
                        }

                        return _context7.abrupt('return', _promise2.default.reject(new Error('NO_METHOD_DEFINED')));

                    case 12:
                        if (fileContent.exitHttpCode) {
                            _context7.next = 14;
                            break;
                        }

                        return _context7.abrupt('return', _promise2.default.reject(new Error('NO_HTTP_CODE_DEFINED')));

                    case 14:
                        return _context7.abrupt('return', fileContent);

                    case 15:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, undefined, [[1, 5]]);
    }));

    return function overrideFileParser(_x3) {
        return _ref7.apply(this, arguments);
    };
}();