'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var findOne = exports.findOne = function findOne(collection, value, eq) {
    var query = {};
    query[value] = { '$eq': eq };
    return collection.find(query)[0];
};

/**
 * Creates a collection in database
 * @param db database instance
 * @param modelName name of model
 * @param opts other options (See lokiJS docs)
 * @returns {Collection|*}
 */
var createCollection = exports.createCollection = function createCollection(db, modelName, opts) {
    var entries = db.getCollection(modelName);
    if (entries) {
        throw new Error('Collection already exists');
    }

    return db.addCollection(modelName, opts);
};

/**
 * Get collection from database
 * @param db database instance
 * @param modelName
 * @returns {Collection}
 */
var findCollection = exports.findCollection = function findCollection(db, modelName) {
    var entries = db.getCollection(modelName);

    if (!entries) {
        throw new Error('MODEL_DOES_NOT_EXIST');
    }

    return entries;
};