'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _api = require('./api');

var _api2 = _interopRequireDefault(_api);

var _error = require('./api/middleware/error');

var _error2 = _interopRequireDefault(_error);

var _loki = require('./api/middleware/loki');

var _loki2 = _interopRequireDefault(_loki);

var _morphling = require('./utils/morphling');

var _morphling2 = _interopRequireDefault(_morphling);

var _overrideRouter = require('./utils/override-router');

var _overrideRouter2 = _interopRequireDefault(_overrideRouter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var serverPort = process.env.NODE_PORT || 8883;

(0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var app, overrideRouters, morphlingInstance;
    return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    app = new _koa2.default();


                    app.use(_error2.default);
                    app.use(_loki2.default);

                    app.use(_api2.default.routes(), _api2.default.allowedMethods());

                    _context.prev = 4;
                    _context.next = 7;
                    return (0, _overrideRouter2.default)();

                case 7:
                    overrideRouters = _context.sent;

                    _lodash2.default.map(overrideRouters, function (router) {
                        app.use(router.routes(), router.allowedMethods());
                    });

                    _context.next = 11;
                    return (0, _morphling2.default)();

                case 11:
                    morphlingInstance = _context.sent;

                    _lodash2.default.map(morphlingInstance, function (router) {
                        app.use(router.routes(), router.allowedMethods());
                    });
                    _context.next = 18;
                    break;

                case 15:
                    _context.prev = 15;
                    _context.t0 = _context['catch'](4);

                    console.error(_context.t0);

                case 18:

                    app.on('error', function (err, ctx) {
                        console.error('server error', err, ctx);
                    });

                    app.listen(serverPort);
                    console.log('Morphling ready on port ' + serverPort);

                case 21:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, undefined, [[4, 15]]);
}))();