'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SOURCE_FILES_LOCATION = process.cwd() + '/src/data';

/**
 * Create a router for a given override file
 *
 * The route is created during the boot, but we check again
 * the override status during the request, to have working toggle
 *
 * @param name
 * @param overrideContent
 * @returns {*}
 */
var createRouter = function createRouter(name, overrideContent) {
    var router = (0, _koaRouter2.default)();

    var _JSON$parse = JSON.parse(overrideContent),
        httpCode = _JSON$parse.httpCode,
        body = _JSON$parse.body,
        route = _JSON$parse.route,
        method = _JSON$parse.method;

    var lowerCasedMethod = method.toLowerCase();

    router[lowerCasedMethod](route, function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
            var _JSON$parse2, overrideStatus;

            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            console.log('pass');

                            _context.t0 = JSON;
                            _context.next = 4;
                            return (0, _utils.readFile)(SOURCE_FILES_LOCATION + '/' + name);

                        case 4:
                            _context.t1 = _context.sent;
                            _JSON$parse2 = _context.t0.parse.call(_context.t0, _context.t1);
                            overrideStatus = _JSON$parse2.overrideStatus;


                            if (overrideStatus) {
                                ctx.body = _lodash2.default.keys(body).length > 0 ? body : null;
                                ctx.status = httpCode;
                            }

                        case 8:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, undefined);
        }));

        return function (_x) {
            return _ref.apply(this, arguments);
        };
    }());

    return router;
};

/**
 * Read override files in data directory and return an array of koa routers ready for use
 * @returns {Promise.<*[]>}
 */
exports.default = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    var overrideFiles;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
            switch (_context3.prev = _context3.next) {
                case 0:
                    _context3.prev = 0;
                    _context3.next = 3;
                    return (0, _utils.readDir)(SOURCE_FILES_LOCATION, function (files) {
                        return _lodash2.default.filter(files, function (file) {
                            return file.includes('morphling-override');
                        });
                    });

                case 3:
                    overrideFiles = _context3.sent;
                    _context3.next = 6;
                    return _promise2.default.all(_lodash2.default.map(overrideFiles, function () {
                        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(fileName) {
                            var fileContent;
                            return _regenerator2.default.wrap(function _callee2$(_context2) {
                                while (1) {
                                    switch (_context2.prev = _context2.next) {
                                        case 0:
                                            _context2.next = 2;
                                            return (0, _utils.readFile)(SOURCE_FILES_LOCATION + '/' + fileName);

                                        case 2:
                                            fileContent = _context2.sent;
                                            return _context2.abrupt('return', createRouter(fileName, fileContent));

                                        case 4:
                                        case 'end':
                                            return _context2.stop();
                                    }
                                }
                            }, _callee2, undefined);
                        }));

                        return function (_x2) {
                            return _ref3.apply(this, arguments);
                        };
                    }()));

                case 6:
                    return _context3.abrupt('return', _context3.sent);

                case 9:
                    _context3.prev = 9;
                    _context3.t0 = _context3['catch'](0);

                    console.error(_context3.t0);

                case 12:
                case 'end':
                    return _context3.stop();
            }
        }
    }, _callee3, undefined, [[0, 9]]);
}));